<?php

namespace app\admin\controller\school\classes\order;

use app\common\controller\Backend;

/**
 * 机构课程售后单
 *
 * @icon fa fa-circle-o
 */
class ServiceOrder extends Backend
{

    /**
     * ServiceOrder模型对象
     * @var \app\admin\model\school\classes\order\ServiceOrder
     */
    protected $model = null;

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\school\classes\order\ServiceOrder;
        $this->view->assign("statusList", $this->model->getStatusList());
        $this->view->assign("serviceStautsList", $this->model->getServiceStautsList());
        $this->view->assign("salesTypeList", $this->model->getSalesTypeList());
        $this->view->assign("platformList", $this->model->getPlatformList());
        $this->view->assign("payTypeList", $this->model->getPayTypeList());
        $this->getAuthMsg();
    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */


    /**
     * 查看
     */
    public function index()
    {
        //当前是否为关联查询
        $this->relationSearch = true;

        $this->searchFields = ["id","order_no","classesorder.order_no","classesorder.pay_no","user_id","shop.name","detail.title","user.nickname","user.realname","user.mobile"];

        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if ($this->request->isAjax()) {
            //如果发送的来源是Selectpage，则转发到Selectpage
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }
            list($where, $sort, $order, $offset, $limit) = $this->buildparams();

            $list = $this->model
                    ->with(['classesorder','user','detail','lib','manystore','shop'])
                    ->where($where)
                    ->order($sort, $order)
                    ->paginate($limit);

            foreach ($list as $row) {
                
                $row->getRelation('classesorder')->visible(['order_no','pay_no']);
				$row->getRelation('user')->visible(['nickname','realname','mobile','avatar']);
				$row->getRelation('detail')->visible(['title','headimage']);
				$row->getRelation('lib')->visible(['title','headimage']);
				$row->getRelation('manystore')->visible(['nickname']);
				$row->getRelation('shop')->visible(['name','logo']);
            }

            $result = array("total" => $list->total(), "rows" => $list->items());

            return json($result);
        }
        return $this->view->fetch();
    }







    /**用户确认
     * @return string
     * @throws \think\Exception
     * @throws \think\exception\DbException
     */
    public function user_confirmation($ids = ""){

        if($this->request->isPost())
        {
            try{
                $params = $this->request->post("row/a");
                $order_no = $params["order_no"];
                $reject_images = $params["reject_images"];
                $reject_reason = $params["reject_reason"];
                $status = $params["status"];
                $model = (new \app\common\model\school\classes\order\ServiceOrder());
                $model->userConfirmation($order_no,$status,$reject_reason,$reject_images,0,true,'admin',$this->auth->id,true);
            }catch (\Exception $e){
                $this->error($e->getMessage());
            }

            $this->success("已完成审核");
        }

        $row = $this->model->where(array('id'=>$ids))->find();
        if (!$row) {
            $this->error(__('No Results were found'));
        }

//        $row = $this->model->get($param['ids']);
           $this->view->assign("statusList", ["yes"=>"同意", "no"=>"拒绝"]);
        $this->view->assign('row', $row);
        return $this->view->fetch();
    }




        /**机构确认
     * @return string
     * @throws \think\Exception
     * @throws \think\exception\DbException
     */
    public function shop_confirmation($ids = ""){

        if($this->request->isPost())
        {
            try{
                $params = $this->request->post("row/a");
                $order_no = $params["order_no"];
                $reject_images = $params["reject_images"];
                $reject_reason = $params["reject_reason"];
                $price = $params["price"];
                $status = $params["status"];
                $model = (new \app\common\model\school\classes\order\ServiceOrder());
                $model->shopConfirmation($order_no,$status,$price,$reject_reason,$reject_images,0,true,'admin',$this->auth->id,true);
            }catch (\Exception $e){
                $this->error($e->getMessage());
            }

            $this->success("已完成审核");
        }

        $row = $this->model->where(array('id'=>$ids))->find();
        if (!$row) {
            $this->error(__('No Results were found'));
        }

//        $row = $this->model->get($param['ids']);
           $this->view->assign("statusList", ["yes"=>"同意", "no"=>"拒绝"]);
        $this->view->assign('row', $row);
        return $this->view->fetch();
    }



    /**系统确认
     * @return string
     * @throws \think\Exception
     * @throws \think\exception\DbException
     */
    public function admin_confirmation($ids = ""){

        if($this->request->isPost())
        {
            try{
                $params = $this->request->post("row/a");
                $order_no = $params["order_no"];
                $reject_images = $params["reject_images"];
                $reject_reason = $params["reject_reason"];
                $status = $params["status"];
                $model = (new \app\common\model\school\classes\order\ServiceOrder());
                $model->adminConfirmation($order_no,$status,$reject_reason,$reject_images,0,true,'admin',$this->auth->id,true);
            }catch (\Exception $e){
                $this->error($e->getMessage());
            }

            $this->success("已完成审核");
        }

        $row = $this->model->where(array('id'=>$ids))->find();
        if (!$row) {
            $this->error(__('No Results were found'));
        }

//        $row = $this->model->get($param['ids']);

        $this->view->assign("statusList", ["yes"=>"同意", "no"=>"拒绝"]);
        $this->view->assign('row', $row);
        return $this->view->fetch();
    }





    /**
     * 后台核销
     * @return string
     * @throws \think\Exception
     * @throws \think\db\exception\BindParamException
     * @throws \think\exception\DbException
     * @throws \think\exception\PDOException
     */
    public function cancel($ids = ''){
        $param = $this->request->param();
        if($this->request->isPost()){
            try{
                if(isset($param['ids']))$ids = $param['ids'];
                //设置模拟资格
                $model = (new \app\common\model\school\classes\order\ServiceOrder());
                $model->cancel($ids,0,true,'admin',$this->auth->id,true);

            }catch (\Exception $e){
                $this->error($e->getMessage());
            }
            $this->success('取消成功!');
        }
        $row = $this->model->get($ids);

        $this->view->assign('vo', $row);
        return $this->view->fetch();
    }







}
